uniform sampler2D flow_sampler;
uniform sampler1D transfer_sampler;
uniform sampler2D arrow_sampler;
uniform sampler2D ball_sampler;
uniform sampler2D xyz;
uniform int shade;
uniform int data;
uniform int arrow;
uniform int ball;
uniform int angle;
uniform int size;

void main()
{	
	vec4 color = vec4(0.0,0.0,0.0,0.0);
	float intensity = 0.0;
	
	if (shade == 1)
	{
		if (data == 0)
		{
			intensity = texture2D(flow_sampler, gl_TexCoord[0].xy).r;
		}
		else if (data == 1)
		{
			intensity = texture2D(flow_sampler, gl_TexCoord[0].xy).g;
		}
		else if (data == 2)
		{
			intensity = texture2D(flow_sampler, gl_TexCoord[0].xy).b;
		}
		color = texture1D(transfer_sampler,intensity);
	}
	else
	{
		if ( arrow == 1)
		{
			
			float winkel, sinus, kosinus;
			mat2 transform;
			vec2 texCoord, transformedCoords;
			// Umwandeln von Gradma in Bogenma
			winkel = gl_TexCoord[1];//radians(texture2D(flow_sampler, gl_TexCoord[0].xy).g);
			// Textur-Koordinaten s und t der Texture Unit 0 abfragen
			texCoord = gl_PointCoord;
			// Anwenden einer Rotation auf die Texturkoordinaten
			sinus = sin(winkel);
			kosinus = cos(winkel);

			transform[0][0] = kosinus;//gl_TexCoord[1].x;
			transform[0][1] = -sinus;//gl_TexCoord[1].y;
			transform[1][0] = sinus;//gl_TexCoord[1].z;
			transform[1][1] = kosinus;//gl_TexCoord[1].w;

			// Translatieren um (-0.5, -0.5)
			texCoord -= 0.5;
			// Drehen mit der Rotationsmatrix
			texCoord = transform * texCoord;
			// Translatieren um (0.5, 0.5)
			texCoord += 0.5;

			// Mit den transformierten Textur-Koordinaten den Sampler aufrufen
			// und der Fragment-Farbe zuweisen
			color = texture2D(arrow_sampler, texCoord);
		}
		else if(ball == 1)
		{
			vec2 ballCoord;
			ballCoord = gl_PointCoord;
			color = texture2D(ball_sampler, ballCoord);
		}
		else
		{
			color = gl_Color;
		}
	}	
	
	gl_FragColor = color;
	
}