//Vertex shader just as fixed pipeline
uniform sampler2D flow_sampler;
uniform sampler2D point_sampler;
uniform sampler2D arrow_sampler;
uniform sampler2D ball_sampler;

uniform sampler2D xyz;
uniform int drawHurricane;
uniform int adaptSize;
uniform int size;

varying vec3 normal;
	
void main()
{
	gl_TexCoord[0] = gl_MultiTexCoord0;

	float winkel, sinus, kosinus;
	
	vec2 texCoor = vec2((gl_Vertex.x+0.5), (gl_Vertex.y+1)/2);
	
	if (drawHurricane == 1)
	{
		sinus = (texture2D(xyz, texCoor).g*2.0-1.0);
	}
	else
	{
		sinus = -(texture2D(xyz, texCoor).g*2.0-1.0);
	}

	kosinus = texture2D(xyz, texCoor).r*2.0-1.0;
	winkel = acos(kosinus);
	if (sinus < 0.0) 
		winkel = 6.283185308-winkel;
	gl_TexCoord[1] = vec4(winkel);
			
	if (adaptSize == 1)
	{
		gl_PointSize = size*texture2D(flow_sampler, texCoor).r+10;
	}
	else
	{
		gl_PointSize = size;
	}

	gl_FrontColor = gl_Color;
	gl_Position = ftransform();
} 
