#include "ColorPoint.h"

/**
* ColorPoint constructor.
* This class handles the points used by the transfer function.
*
*/
ColorPoint::ColorPoint () 
{
	xValue = 0;
	color = new Color(0.f,0.f,0.f);
}

/**
*@override
* ColorPoint constructor.
* This class handles the points used by the transfer function.
* Each point has a x-value and a color.
*
* @param float x
* @param Color* c
*/
ColorPoint::ColorPoint (float x, Color* c) 
{
	this->xValue = x;
	this->color = c;
}

/**
* Get color of color point.
*
* @return Color* color
*/
Color* ColorPoint::getColor() 
{
	return color;
}

/**
* Set color of color point.
*
* @param Color* c
*/
void ColorPoint::setColor(Color* c)
{
	color = c;
}

/**
* Get x value of point.
*
* @return float xValue
*/
float ColorPoint::getX() 
{
	return xValue;
}

/**
* Set x value of point.
*
* @param float x
*/
void ColorPoint::setX(float x)
{
	xValue = x;
}